
[![GitHub Org Follow](https://img.shields.io/github/followers/github?style=social)](https://github.com/github)
[![Twitter Follow](https://img.shields.io/badge/follow-%40github-1DA1F2?logo=twitter&style=social)](https://twitter.com/github)
[![Youtube Channel Views](https://img.shields.io/youtube/channel/views/UC7c3Kb6jYCRj4JOHHZTxKsQ?style=social)](https://www.youtube.com/@GitHub/search?query=copilot)
[![Try Copilot free trial](https://img.shields.io/badge/Try%20Copilot-Free%20trial-success)](https://github.com/github-copilot/signup)

# Your AI pair programmer
### **Get Code Suggestions in real-time, right in your IDE**

![cover](https://user-images.githubusercontent.com/37570492/212964557-8d832278-61bb-4288-a8a7-47f35859e868.gif)

### **What’s GitHub Copilot**
GitHub Copilot provides autocomplete-style suggestions from an AI pair programmer as you code. You can receive suggestions from GitHub Copilot either by starting to write the code you want to use, or by writing a natural language comment describing what you want the code to do. 

### **Privacy**

Your code is yours. We follow responsible practices in accordance with our [Privacy Statement](https://docs.github.com/en/site-policy/privacy-policies/github-privacy-statement) to ensure that your code snippets will not be used as suggested code for other users of GitHub Copilot.

[Start a free trial with GitHub Copilot](https://github.com/login?return_to=%2Fgithub-copilot%2Fsignup)

### **What can you do with GitHub Copilot?**
**Convert comments to code** <br />
GitHub Copilot uses a special version of GPT-3 that has been trained on a large body of public source code. It is as good at writing natural language as it is at writing code, so in fact it can complete your comments for you. In the example below, we first let it complete our explanation, and then, line by line, we tab through the code that does what we just said in English.

![comment-to-code](https://user-images.githubusercontent.com/37570492/212965036-26579d9f-cfaf-44eb-90fb-76421dc7ab9d.gif)

**Create unit tests** <br />
An important use case of GitHub Copilot is to take some of the drudgery out of writing unit tests. Below, we already have an implementation of a function that computes the common prefix of two lists, and we want to test that. To do so, we import the unit test package, and then we start writing a test function to let Copilot generate the asserts which we accept just by hitting the <kbd>Tab</kbd> key.

![unit-test](https://user-images.githubusercontent.com/37570492/212964557-8d832278-61bb-4288-a8a7-47f35859e868.gif)

**Create a SQL query** <br />
What’s cooler than generating code in Go? Generating Go with embedded SQL! To make GitHub Copilot do that, just show it the schema as CREATE TABLE statements. And then, it nicely writes a query embedded in Go, converting the result to a Go class as you would have done yourself:

![sql-go](https://user-images.githubusercontent.com/37570492/212965203-c9623e27-4fff-4961-a7f4-4d14625dd17c.gif)

[Start a free trial with GitHub Copilot](https://github.com/login?return_to=%2Fgithub-copilot%2Fsignup)

### **GitHub Copilot for Business gives organizations** 
- **The power of AI.** Millions of developers have already used GitHub Copilot to build software faster, stay in the flow longer, and solve problems in new ways—all right from their editor of choice. 

- **Simple license management.** Administrators can enable GitHub Copilot for their teams and select which organizations, teams, and developers receive licenses. 
 
- **Organization-wide policy management.** You can easily set policy controls to enforce user settings for public code matching on behalf of your organization. 

- **Your code is safe with us.** With Copilot for Business, we won’t retain code snippets, store or share your code regardless if the data is from public repositories, private repositories, non-GitHub repositories, or local files. 

**The numbers speak for themselves**
<br/>
[Research](https://github.blog/2022-09-07-research-quantifying-github-copilots-impact-on-developer-productivity-and-happiness/) has found GitHub Copilot helps developers code faster, focus on solving bigger problems, stay in the flow longer, and feel more fulfilled with their work.
- **74%** of developers are able to focus on more satisfying work
- **88%** feel more productive
- **96%** of developers are faster with repetitive tasks

To learn more, visit [https://github.com/features/copilot](https://github.com/features/copilot)

### **Powered by OpenAI**
It is powered by OpenAI Codex to work in real time, right from your editor. GitHub Copilot improves developer productivity and happiness by reducing disruptions, improving flow and increasing the amount of time a developer spends doing satisfying work. 

Unlike other code assistants, GitHub Copilot offers suggestions from a model that OpenAI built from billions of lines of open-source code. 

### **Supported languages, frameworks, and IDEs**
GitHub Copilot works on any language, including Java, PHP, Python, JavaScript, Ruby, Go, C#, or C++. Because it’s been trained on languages in public repositories, it works for most popular languages, libraries and frameworks. It’s also integrated into your editor, and fast enough to use as you type.

### **FAQ**
Got a question? We probably have the answers. [Check our FAQ](https://github.com/features/copilot/).

### **Trusted by Developers Everyday**

- "This is the single most mind-blowing application of machine learning I’ve ever seen." - _Mike Krieger // Co-founder, Instagram_

- "GitHub Copilot works shockingly well. I will never develop software without it again." - _Lars Gyrup Brink Nielsen_

- "I was stunned when I started writing Clojure with GitHub Copilot and it filled an idiomatic namespace require, just like I was going to write it." - _Gunnika Batra // Senior Analyst_

- "Trying to code in an unfamiliar language by googling everything is like navigating a foreign country with just a phrasebook. Using GitHub Copilot is like hiring an interpreter." - _Harri Edwards // Open AI_

### Note about Copilot Chat Technical Preview

By using Copilot Chat you agree to [GitHub Copilot chat preview terms](https://docs.github.com/en/early-access/copilot/github-copilot-chat-technical-preview-license-terms). Review the [transparency note](https://aka.ms/CopilotChatTransparencyNote) to understand about usage, limitations and ways to improve Copilot Chat during the technical preview.


### Troubleshooting
We’d love to get your help in making GitHub Copilot better! If you have feedback or encounter any problems, please reach out on our [Feedback forum](https://github.com/orgs/community/discussions/categories/copilot).
